#ifndef SOUND_H_INCLUDED
#define SOUND_H_INCLUDED

#include "pc6001v.h"
#include "SCritical.h"


// Xg[̍ő吔
// PSG + TAPE + VOICE = 3
#define	MAXSTREAM	(3)
// obt@TCY̔{
#define	MULTI		(2)

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// Oobt@IuWFNg
//   Iɂ̓TCYMULTI{邪ΊOIɂ͓{̂悤ɐU
//   ǂݏ͑S̈ɑ΂čsȂ邪TCY擾͓{
//   ܂I[o[t[h~X|XۂĂ...͂
class cRing : public SCritical {
private:
	int *Buffer;			// obt@ւ̃|C^
	
	int Size;				// obt@TCY(f[^)
	int Wpt;				// ݃|C^
	int Rpt;				// Ǎ݃|C^
	int Num;				// ǃf[^
	
public:
	cRing();								// RXgN^
	virtual ~cRing();						// fXgN^
	
	BOOL InitBuffer( int );					// obt@
	
	virtual int Get( int = -1 );			// Ǎ
	virtual BOOL Put( int );				// 
	
	int ReadySize();						// ǃf[^擾
	int FreeSize();							// cobt@擾
	int GetSize();							// obt@TCY擾
};


// TEhfoCXIuWFNg
class SndDev : public cRing {
protected:
	int Volume;				// 
	int LPF_Mem;			// [pXtB^p[N
	int LPF_k;				// [pXtB^W
	
	virtual int GetSampleRate();			// TvO[g擾
	int LPF( int );							// [pXtB^
	
public:
	SndDev();								// RXgN^
	virtual ~SndDev();						// fXgN^
	
	int Get( int = -1 );					// Ǎ
	
	void SetLPF( int );						// [pXtB^ JbgItgݒ
	virtual void SetVolume( int );			// ʐݒ
	virtual int SoundUpdate( int );			// Xg[XV
};


// TEhIuWFNg
class SND6 : public cRing {
private:
	SDL_AudioSpec ASpec;	// I[fBIXybN
	SndDev *RB[MAXSTREAM];	// Xg[|C^z
	int Volume;				// }X^[
	
public:
	SND6();									// RXgN^
	~SND6();								// fXgN^
	
	BOOL Init( void *, void (*)(void *, Uint8 *, int ), int, int );	// 
	
	BOOL ConnectStream( SndDev * );			// Xg[ڑ
	
	void Play();							// Đ
	void Pause();							// ~
	
	int GetSampleRate();					// TvO[g擾
	void SetVolume( int );					// }X^[ʐݒ
	
	int PreUpdate( int, cRing * = NULL );	// TEhOXV֐
	void Update( Uint8 *, int );			// TEhXV֐
};

#endif	// SOUND_H_INCLUDED
