#ifndef GRAPH_H_INCLUDED
#define GRAPH_H_INCLUDED

#include "pc6001v.h"
#include "p6device.h"



////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class DSP6 : public P6DEVICE {
protected:
	SDL_Surface *SBuf;		// Tuobt@|C^
	SDL_Rect ScrPos;		// ʕ\|WV
	
	SDL_Color GPal[256];	// pbg
	
	int Bpp;				// J[[h
	int SLBr;				// XLCPx
	
	BOOL SetScreenSurface();				// XN[T[tFX쐬
	
	BOOL UpdateSubBuf();					// Tuobt@XV
	BOOL RefreshSubBuf();					// Tuobt@tbV
	
public:
	DSP6( VM6 *, const P6ID& );				// RXgN^
	~DSP6();								// fXgN^
	
	BOOL Init( int, int );					// 
	
	SDL_Surface *ResizeScreen();			// XN[TCYύX
	BOOL SetPalette( SDL_Surface * );		// T[tFXɃpbgݒ
	
	void DrawScreen();						// ʍXV
	void SnapShot( char * );				// XibvVbg
	
	int ScreenX();							// LXN[擾
	int ScreenY();							// LXN[擾
};


#endif	// GRAPH_H_INCLUDED
