/*
	Skelton for Z-80 PC Emulator

	Author : Takeda.Toshiya
	Date   : 2004.04.26 -

	[ Device Base Class ]
*/
//  x[Xɂ݂낪׍H(ȗ)̂ł

#ifndef P6DEVICE_H_INCLUDED
#define P6DEVICE_H_INCLUDED

#include "pc6001v.h"
#include "pc60.h"

// WfoCX
class P6DEVICE {
public:
	typedef DWORD P6ID;
	
protected:
	VM6* vm;
	P6ID p6id;		// foCXID
	
public:
	P6DEVICE( VM6* parent_vm, const P6ID& id ) : vm( parent_vm ), p6id( id ){}
	virtual ~P6DEVICE(){}
	
	const P6ID& GetID() const { return p6id; }
};


// CxgtfoCX
class P6DEVENT : public P6DEVICE {
public:
	P6DEVENT( VM6* parent_vm, const P6ID& id ) : P6DEVICE( parent_vm, id ){}	// RXgN^
	virtual ~P6DEVENT(){};						// fXgN^
	
	virtual void EventCallback( int, int ){}	// CxgR[obN֐
};


#endif		// P6DEVICE_H_INCLUDED
